/*

Scrivere un programma per la gestione dei libri e dei prestiti di una biblioteca universitaria.
I libri sono caratterizzati dalle seguenti informazioni: titolo, autore, collocazione, numero di copie,  genere del libro.
I libri sono inseriti in una tabella allocata dinamicamente avente 5 righe, una per ogni genere di libro.
Per quanto riguarda i prestiti, essi sono caratterizzati dalle seguenti informazioni: matricola dello studente, titolo e collocazione del libro, giorno del prestito, corso di laurea.
Ogni nuovo prestito viene inserito in un vettore di 4 liste, una per ogni corso di laurea.
Linserimento nella lista relativa al corso di laurea viene eseguito solo se esiste almeno una copia del libro.
Se la copia del libro esiste, il numero di copie viene diminuito.
Ogni lista  ordinata rispetto alla matricola.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento di un nuovo libro;
2.Visualizzazione dei libri relativi a un certo genere;
3.Inserimento ordinato di un prestito nella lista relativa al corso di laurea dopo averne verificato la presenza nella tabella e aggiornamento del numero di copie dei libri;
4.Visualizzazione dei prestiti relativi agli studenti appartenenti a un certo corso di laurea.

Liberare la memoria allocata dinamicamente.


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
	char titolo[20];
	char autore[20];
	int collocazione;
	int copie;
	int genere;
		}libro;

typedef struct{
	long matricola;
	char titolo[20];
	int collocazione;
	char data[11];
	int corso;
		}prestito;

struct atomo{
	prestito dato;
	struct atomo *next;
	};

void leggi(libro *x);
void ins_tab(libro *T[5],int *N);
void vis_riga(libro *T[5],int *N);
void in_lista(struct atomo *tl[4],libro *T[5],int *N);
void vis_lista(struct atomo *tl);
void libera_lista(struct atomo **tl);
void menu();


main(){

	libro *T[5],x;
	int N[5],scelta,i;
	struct atomo *L[4];

	for(i=0;i<5;i++)
		{
			T[i]=NULL;
			N[i]=0;
		}

	for(i=0;i<4;i++)
		L[i]=NULL;

	do{
		menu();
		scanf("%d",&scelta);
		switch(scelta){

			case 1: ins_tab(T,N);
					break;

			case 2: vis_riga(T,N);
					break;

			case 3: in_lista(L,T,N);
					break;
			case 4: printf("Corso?\n");
					scanf("%d",&i);
					vis_lista(L[i]);
					break;

			case 0: printf("Fine\n");
					break;
			default:printf("Tasto errato\n");}
			}while(scelta!=0);

			for(i=0;i<5;i++)
				free(T[i]);
			for(i=0;i<4;i++)
				libera_lista(&L[i]);
			}

void leggi(libro *x)
{
	printf("Titolo:\n");
	scanf("%s",(*x).titolo);
	printf("Autore:\n");
	scanf("%s",(*x).autore);
	printf("Collocazione:\n");
	scanf("%d",&(*x).collocazione);
	printf("Copie\n");
	scanf("%d",&(*x).copie);
	printf("Genere:\n");
	scanf("%d",&(*x).genere);
	}


void ins_tab(libro *T[5],int *N)
{
	libro x,*g;

    leggi(&x);
	g=realloc(T[x.genere],sizeof (libro)*(N[x.genere]+1));
	if(g==NULL)
		{
			printf("Memoria non allocata\n");
			return;
		}
	T[x.genere]=g;
	T[x.genere][N[x.genere]]=x;
	N[x.genere]++;
}

void vis_riga(libro *T[5],int *N)
{
	int riga,i;

	printf("Genere:\n");
	scanf("%d",&riga);
	for(i=0;i<N[riga];i++)
		{
			printf("Titolo:%s\n",T[riga][i].titolo);
			printf("Autore:%s\n",T[riga][i].autore);
			printf("Collocazione:%d\n",T[riga][i].collocazione);
			printf("Copie:%d\n",T[riga][i].copie);
			printf("Genere:%d\n\n",T[riga][i].genere);
		}
	}


void in_lista(struct atomo *tl[4],libro *T[5],int *N)
{
	prestito x;
	int j,genere;
	struct atomo *aux,*l1,*l2;
	int i;

	printf("Titolo:\n");
	scanf("%s",x.titolo);
	printf("Genere:\n");
	scanf("%d",&genere);

	for(j=0;j<N[genere];j++)
			if(strcmp(T[genere][j].titolo,x.titolo)==0)
				{
					printf("Trovato\n");
					break;
				}
	if(j>=N[genere])
		{
			printf("Non trovato!\n");
			return;
		}

	if(T[genere][j].copie<=0)
		{
			printf("Non e' presente alcuna copia del libro\n");
			return;
			}

	(T[genere][j].copie)--;

	aux=malloc(sizeof (struct atomo));
	if(aux==NULL)
		{
			printf("Memoria non allocata\n");
			return;
		}

	printf("Matricola:\n");
	scanf("%ld",&x.matricola);
	printf("Data:\n");
	scanf("%s",x.data);
	printf("Corso: \n");
	scanf("%d",&x.corso);
	x.collocazione=T[genere][j].collocazione;

	aux->dato=x;
    i=x.corso;

	if(tl[i]==NULL || aux->dato.matricola<tl[i]->dato.matricola)
		{
			aux->next=tl[i];
			tl[i]=aux;
			return;
		}
	l2=tl[i];
	l1=l2->next;
	while(l1!=NULL)
		if(l1->dato.matricola>aux->dato.matricola)
			break;
		else
			{
				l1=l1->next;
				l2=l2->next;
			}
		l2->next=aux;
		aux->next=l1;
	}

void vis_lista(struct atomo *tl)
{
	struct atomo *aux;

	aux=tl;
	while(aux!=NULL)
		{
			printf("Matricola:%ld\n",aux->dato.matricola);
			printf("Titolo:%s\n",aux->dato.titolo);
			printf("Collocazione:%d\n",aux->dato.collocazione);
			printf("Data:%s\n",aux->dato.data);
			printf("Corso:%d\n\n",aux->dato.corso);
			aux=aux->next;
			}
}

void libera_lista(struct atomo **tl)
{
	struct atomo *aux;
	while(*tl!=NULL)
		{
			aux=*tl;
			*tl=aux->next;
			free(aux);
		}
	}

void menu()
{
	printf("GESTIONE DEI LIBRI E DEI PRESTITI DI UNA BIBLIOTECA UNIVERSITARIA\n\n");
	printf("Scegli tra:\n\n");
	printf("1)Inserimento di un nuovo libro\n");
	printf("2)Visualizzazione dei libri di un certo genere\n");
	printf("3)Inserimento ordinato di un prestito in lista\n");
	printf("4)Visualizzazione dei prestiti relativi a studenti di un corso di laurea\n");
	printf("0)Fine\n\n");
}



